diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
new file mode 100644
index 000000000..176cf952c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
@@ -0,0 +1,930 @@
+package net.minecraft.core.player.inventory;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.IPainted;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.List;
+
+import static net.minecraft.core.player.inventory.menu.MenuInventoryCreative.CREATIVE_COLUMNS;
+import static net.minecraft.core.player.inventory.menu.MenuInventoryCreative.CREATIVE_PAGE_SIZE;
+
+public final class CreativeMenuContents {
+
+	private static final DyeColor[] RAINBOW_ORDER = {
+		DyeColor.RED,
+		DyeColor.ORANGE,
+		DyeColor.YELLOW,
+		DyeColor.LIME,
+		DyeColor.GREEN,
+		DyeColor.CYAN,
+		DyeColor.LIGHT_BLUE,
+		DyeColor.BLUE,
+		DyeColor.PURPLE,
+		DyeColor.MAGENTA,
+		DyeColor.PINK,
+		DyeColor.BROWN,
+		DyeColor.WHITE,
+		DyeColor.SILVER,
+		DyeColor.GRAY,
+		DyeColor.BLACK
+	};
+
+	public CreativeMenuContents() {
+	}
+
+	/** Inserts {@code count} empty slots into the creative grid at the current catalog position. */
+	public static void addGap(List<ItemStack> list, int count) {
+		for (int i = 0; i < count; i++) {
+			list.add(null);
+		}
+	}
+
+	/**
+	 * Pads the creative inventory line until the next line is reached. If no spaces need to be filled, nothing happens.
+	 */
+	public static void newLine(@NotNull List<ItemStack> list) {
+		int remainder = list.size() % CREATIVE_COLUMNS;
+		if (remainder != 0) {
+			addGap(list, CREATIVE_COLUMNS - remainder);
+		}
+	}
+
+	/**
+	 * Pads the creative inventory until the next page is reached.
+	 */
+	public static void newPage(@NotNull List<ItemStack> list) {
+		int n = list.size();
+		if (n == 0) {
+			return;
+		}
+		int rem = n % CREATIVE_PAGE_SIZE;
+		if (rem != 0) {
+			addGap(list, CREATIVE_PAGE_SIZE - rem);
+		}
+	}
+
+	public static void populate(List<ItemStack> list) {
+		addNaturalTypes(list);
+		newPage(list);
+
+		addStoneTypes(list);
+		newPage(list);
+
+		addOreTypes(list);
+		newPage(list);
+
+		addRedstoneTypes(list);
+		newPage(list);
+
+		addLogTypes(list);
+		newLine(list);
+		addWoodTypes(list);
+		newPage(list);
+
+		addPaintedTypes(list);
+
+		addOrganicTypes(list);
+		newPage(list);
+
+		addWorkstationsAndGlass(list);
+		newPage(list);
+
+		addTools(list);
+		newPage(list);
+
+		addArmor(list);
+		newPage(list);
+
+		addMiscTools(list);
+		newPage(list);
+
+		addFood(list);
+		newPage(list);
+
+		addDyes(list);
+		newPage(list);
+
+		addOreProducts(list);
+		addBasics(list);
+		addMobDrops(list);
+		newPage(list);
+
+		addStorageTypes(list);
+		newPage(list);
+
+		addPlaceables(list);
+		newPage(list);
+
+		addRecords(list);
+		newPage(list);
+	}
+
+	private static void addTools(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.TOOL_SHOVEL_WOOD));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_WOOD));
+		list.add(new ItemStack(Items.TOOL_AXE_WOOD));
+		list.add(new ItemStack(Items.TOOL_HOE_WOOD));
+		list.add(new ItemStack(Items.TOOL_SWORD_WOOD));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_SHOVEL_STONE));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_STONE));
+		list.add(new ItemStack(Items.TOOL_AXE_STONE));
+		list.add(new ItemStack(Items.TOOL_HOE_STONE));
+		list.add(new ItemStack(Items.TOOL_SWORD_STONE));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_SHOVEL_IRON));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_IRON));
+		list.add(new ItemStack(Items.TOOL_AXE_IRON));
+		list.add(new ItemStack(Items.TOOL_HOE_IRON));
+		list.add(new ItemStack(Items.TOOL_SWORD_IRON));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_SHOVEL_GOLD));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_GOLD));
+		list.add(new ItemStack(Items.TOOL_AXE_GOLD));
+		list.add(new ItemStack(Items.TOOL_HOE_GOLD));
+		list.add(new ItemStack(Items.TOOL_SWORD_GOLD));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_SHOVEL_DIAMOND));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_DIAMOND));
+		list.add(new ItemStack(Items.TOOL_AXE_DIAMOND));
+		list.add(new ItemStack(Items.TOOL_HOE_DIAMOND));
+		list.add(new ItemStack(Items.TOOL_SWORD_DIAMOND));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_SHOVEL_STEEL));
+		list.add(new ItemStack(Items.TOOL_PICKAXE_STEEL));
+		list.add(new ItemStack(Items.TOOL_AXE_STEEL));
+		list.add(new ItemStack(Items.TOOL_HOE_STEEL));
+		list.add(new ItemStack(Items.TOOL_SWORD_STEEL));
+	}
+
+	private static void addMiscTools(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.TOOL_FIRESTRIKER_IRON));
+		list.add(new ItemStack(Items.TOOL_FIRESTRIKER_STEEL));
+
+		list.add(new ItemStack(Items.TOOL_SHEARS));
+		list.add(new ItemStack(Items.TOOL_SHEARS_STEEL));
+		newLine(list);
+
+		addBucketVariants(list, Items.BUCKET_IRON);
+		newLine(list);
+		addBucketVariants(list, Items.BUCKET_STEEL);
+		newLine(list);
+
+		list.add(new ItemStack(Items.PAINTBRUSH));
+		list.add(new ItemStack(Items.WAND_MONSTER_SPAWNER));
+		list.add(new ItemStack(Items.WAND_NBT));
+		list.add(new ItemStack(Items.TOOL_FISHINGROD));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_BOW));
+		list.add(new ItemStack(Items.AMMO_ARROW));
+		list.add(new ItemStack(Items.AMMO_ARROW_GOLD));
+		list.add(new ItemStack(Items.AMMO_ARROW_FLAMING));
+		newLine(list);
+
+		list.add(new ItemStack(Items.HANDCANNON_UNLOADED));
+		list.add(new ItemStack(Items.AMMO_CHARGE_EXPLOSIVE));
+		list.add(new ItemStack(Items.AMMO_FIREBALL));
+		newLine(list);
+
+		list.add(new ItemStack(Items.TOOL_COMPASS));
+		list.add(new ItemStack(Items.TOOL_CLOCK));
+		list.add(new ItemStack(Items.TOOL_CALENDAR));
+		list.add(new ItemStack(Items.MAP));
+		list.add(new ItemStack(Items.ROPE));
+		list.add(new ItemStack(Items.LABEL));
+		newLine(list);
+	}
+
+	private static void addStoneTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.STONE);
+		addBlock(list, Blocks.MOSS_STONE);
+		addBlock(list, Blocks.COBBLE_STONE);
+		addBlock(list, Blocks.STAIRS_COBBLE_STONE);
+		addBlock(list, Blocks.SLAB_COBBLE_STONE);
+		addBlock(list, Blocks.COBBLE_STONE_MOSSY);
+
+		addBlock(list, Blocks.BRICK_STONE);
+		addBlock(list, Blocks.STAIRS_BRICK_STONE);
+		addBlock(list, Blocks.SLAB_BRICK_STONE);
+
+		addBlock(list, Blocks.STONE_POLISHED);
+		addBlock(list, Blocks.SLAB_STONE_POLISHED);
+
+		addBlock(list, Blocks.BRICK_STONE_POLISHED);
+		addBlock(list, Blocks.STAIRS_BRICK_STONE_POLISHED);
+		addBlock(list, Blocks.SLAB_BRICK_STONE_POLISHED);
+		addBlock(list, Blocks.BRICK_STONE_POLISHED_MOSSY);
+		list.add(new ItemStack(Items.STATUE_STONE));
+		addBlock(list, Blocks.BUTTON_STONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_STONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_STONE);
+		newPage(list);
+
+		addBlock(list, Blocks.BASALT);
+		addBlock(list, Blocks.MOSS_BASALT);
+
+		addBlock(list, Blocks.COBBLE_BASALT);
+		addBlock(list, Blocks.STAIRS_COBBLE_BASALT);
+		addBlock(list, Blocks.SLAB_COBBLE_BASALT);
+		addBlock(list, Blocks.COBBLE_BASALT_MOSSY);
+
+		addBlock(list, Blocks.BRICK_BASALT);
+		addBlock(list, Blocks.STAIRS_BRICK_BASALT);
+		addBlock(list, Blocks.SLAB_BRICK_BASALT);
+
+		addBlock(list, Blocks.BASALT_POLISHED);
+		addBlock(list, Blocks.SLAB_BASALT_POLISHED);
+		list.add(new ItemStack(Items.STATUE_BASALT));
+		addBlock(list, Blocks.BUTTON_BASALT);
+		addBlock(list, Blocks.PRESSURE_PLATE_BASALT);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_BASALT);
+		newPage(list);
+
+		addBlock(list, Blocks.LIMESTONE);
+		addBlock(list, Blocks.MOSS_LIMESTONE);
+
+		addBlock(list, Blocks.COBBLE_LIMESTONE);
+		addBlock(list, Blocks.STAIRS_COBBLE_LIMESTONE);
+		addBlock(list, Blocks.SLAB_COBBLE_LIMESTONE);
+		addBlock(list, Blocks.COBBLE_LIMESTONE_MOSSY);
+
+		addBlock(list, Blocks.BRICK_LIMESTONE);
+		addBlock(list, Blocks.STAIRS_BRICK_LIMESTONE);
+		addBlock(list, Blocks.SLAB_BRICK_LIMESTONE);
+
+		addBlock(list, Blocks.LIMESTONE_POLISHED);
+		addBlock(list, Blocks.SLAB_LIMESTONE_POLISHED);
+		list.add(new ItemStack(Items.STATUE_LIMESTONE));
+		addBlock(list, Blocks.BUTTON_LIMESTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_LIMESTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_LIMESTONE);
+		newPage(list);
+
+		addBlock(list, Blocks.GRANITE);
+		addBlock(list, Blocks.MOSS_GRANITE);
+
+		addBlock(list, Blocks.COBBLE_GRANITE);
+		addBlock(list, Blocks.STAIRS_COBBLE_GRANITE);
+		addBlock(list, Blocks.SLAB_COBBLE_GRANITE);
+		addBlock(list, Blocks.COBBLE_GRANITE_MOSSY);
+
+		addBlock(list, Blocks.BRICK_GRANITE);
+		addBlock(list, Blocks.STAIRS_BRICK_GRANITE);
+		addBlock(list, Blocks.SLAB_BRICK_GRANITE);
+
+		addBlock(list, Blocks.GRANITE_POLISHED);
+		addBlock(list, Blocks.SLAB_GRANITE_POLISHED);
+		list.add(new ItemStack(Items.STATUE_GRANITE));
+		addBlock(list, Blocks.BUTTON_GRANITE);
+		addBlock(list, Blocks.PRESSURE_PLATE_GRANITE);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_GRANITE);
+		newPage(list);
+
+		addBlock(list, Blocks.PERMAFROST);
+
+		addBlock(list, Blocks.COBBLE_PERMAFROST);
+		addBlock(list, Blocks.STAIRS_COBBLE_PERMAFROST);
+		addBlock(list, Blocks.SLAB_COBBLE_PERMAFROST);
+
+		addBlock(list, Blocks.BRICK_PERMAFROST);
+		addBlock(list, Blocks.STAIRS_BRICK_PERMAFROST);
+		addBlock(list, Blocks.SLAB_BRICK_PERMAFROST);
+
+		addBlock(list, Blocks.PERMAFROST_POLISHED);
+		addBlock(list, Blocks.SLAB_PERMAFROST_POLISHED);
+		list.add(new ItemStack(Items.STATUE_PERMAFROST));
+		addBlock(list, Blocks.BUTTON_PERMAFROST);
+		addBlock(list, Blocks.PRESSURE_PLATE_PERMAFROST);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_PERMAFROST);
+		newPage(list);
+
+		addBlock(list, Blocks.NETHERRACK);
+
+		addBlock(list, Blocks.COBBLE_NETHERRACK);
+		addBlock(list, Blocks.STAIRS_COBBLE_NETHERRACK);
+		addBlock(list, Blocks.SLAB_COBBLE_NETHERRACK);
+		addBlock(list, Blocks.COBBLE_NETHERRACK_CRYSTALLINE);
+
+		addBlock(list, Blocks.BRICK_NETHERRACK);
+		addBlock(list, Blocks.STAIRS_BRICK_NETHERRACK);
+		addBlock(list, Blocks.SLAB_BRICK_NETHERRACK);
+
+		addBlock(list, Blocks.NETHERRACK_POLISHED);
+		addBlock(list, Blocks.SLAB_NETHERRACK_POLISHED);
+		list.add(new ItemStack(Items.STATUE_NETHERRACK));
+		addBlock(list, Blocks.BUTTON_NETHERRACK);
+		addBlock(list, Blocks.PRESSURE_PLATE_NETHERRACK);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_NETHERRACK);
+		newPage(list);
+
+		addBlock(list, Blocks.GLOOMSTONE);
+
+		addBlock(list, Blocks.COBBLE_GLOOMSTONE);
+		addBlock(list, Blocks.STAIRS_COBBLE_GLOOMSTONE);
+		addBlock(list, Blocks.SLAB_COBBLE_GLOOMSTONE);
+
+		addBlock(list, Blocks.BRICK_GLOOMSTONE);
+		addBlock(list, Blocks.STAIRS_BRICK_GLOOMSTONE);
+		addBlock(list, Blocks.SLAB_BRICK_GLOOMSTONE);
+
+		addBlock(list, Blocks.GLOOMSTONE_POLISHED);
+		addBlock(list, Blocks.SLAB_GLOOMSTONE_POLISHED);
+		list.add(new ItemStack(Items.STATUE_GLOOMSTONE));
+		addBlock(list, Blocks.BUTTON_GLOOMSTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_GLOOMSTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_GLOOMSTONE);
+		newPage(list);
+
+		addBlock(list, Blocks.SANDSTONE);
+		addBlock(list, Blocks.STAIRS_SANDSTONE);
+		addBlock(list, Blocks.SLAB_SANDSTONE);
+		addBlock(list, Blocks.BRICK_SANDSTONE);
+		addBlock(list, Blocks.STAIRS_BRICK_SANDSTONE);
+		addBlock(list, Blocks.SLAB_BRICK_SANDSTONE);
+		addBlock(list, Blocks.BUTTON_SANDSTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_SANDSTONE);
+		newLine(list);
+
+		addBlock(list, Blocks.BRIMSTONE);
+		addBlock(list, Blocks.STAIRS_BRIMSTONE);
+		addBlock(list, Blocks.SLAB_BRIMSTONE);
+		addBlock(list, Blocks.BRICK_BRIMSTONE);
+		addBlock(list, Blocks.STAIRS_BRICK_BRIMSTONE);
+		addBlock(list, Blocks.SLAB_BRICK_BRIMSTONE);
+		addBlock(list, Blocks.BUTTON_BRIMSTONE);
+		addBlock(list, Blocks.PRESSURE_PLATE_BRIMSTONE);
+		newPage(list);
+
+		addBlock(list, Blocks.MARBLE);
+
+		addBlock(list, Blocks.BRICK_MARBLE);
+		addBlock(list, Blocks.STAIRS_BRICK_MARBLE);
+		addBlock(list, Blocks.SLAB_BRICK_MARBLE);
+
+		addBlock(list, Blocks.PILLAR_MARBLE);
+		addBlock(list, Blocks.CAPSTONE_MARBLE);
+		addBlock(list, Blocks.SLAB_CAPSTONE_MARBLE);
+		list.add(new ItemStack(Items.STATUE_MARBLE));
+		list.add(new ItemStack(Items.STATUE_PIGMAN));
+		newLine(list);
+
+		addBlock(list, Blocks.SLATE);
+		addBlock(list, Blocks.LAYER_SLATE);
+
+		addBlock(list, Blocks.BRICK_SLATE);
+		addBlock(list, Blocks.STAIRS_BRICK_SLATE);
+		addBlock(list, Blocks.SLAB_BRICK_SLATE);
+
+		addBlock(list, Blocks.SLATE_POLISHED);
+		addBlock(list, Blocks.SLAB_SLATE_POLISHED);
+		list.add(new ItemStack(Items.STATUE_SLATE));
+		newPage(list);
+	}
+
+	private static void addLogTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.LOG_OAK);
+		addBlock(list, Blocks.LOG_OAK_MOSSY);
+		addBlock(list, Blocks.LOG_PINE);
+		addBlock(list, Blocks.LOG_BIRCH);
+		addBlock(list, Blocks.LOG_CHERRY);
+		addBlock(list, Blocks.LOG_EUCALYPTUS);
+		addBlock(list, Blocks.LOG_THORN);
+		addBlock(list, Blocks.LOG_PALM);
+		addBlock(list, Blocks.LOG_SCORCHED);
+		newPage(list);
+	}
+
+	private static void addWoodTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.PRESSURE_PLATE_PLANKS_OAK);
+		addBlock(list, Blocks.BUTTON_PLANKS_OAK);
+		addBlock(list, Blocks.PLANKS_OAK);
+		addBlock(list, Blocks.STAIRS_PLANKS_OAK);
+		addBlock(list, Blocks.SLAB_PLANKS_OAK);
+		addBlock(list, Blocks.FENCE_PLANKS_OAK);
+		addBlock(list, Blocks.FENCE_GATE_PLANKS_OAK);
+		addBlock(list, Blocks.TRAPDOOR_PLANKS_OAK);
+		addBlock(list, Blocks.CHEST_PLANKS_OAK);
+		list.add(new ItemStack(Items.DOOR_OAK));
+		list.add(new ItemStack(Items.SIGN));
+	}
+
+	private static void addPaintedTypes(List<ItemStack> list) {
+		for (int i = 0; i < RAINBOW_ORDER.length; i += 2) {
+			addPainted(list, RAINBOW_ORDER[i]);
+            newLine(list);
+            addPainted(list, RAINBOW_ORDER[i + 1]);
+            newPage(list);
+		}
+	}
+
+	private static void addPainted(@NotNull List<ItemStack> list, DyeColor color) {
+		list.add(new ItemStack(Blocks.LAMP_IDLE, 1, painted(Blocks.LAMP_IDLE).toMetadata(color)));
+		addPaintedWoodBlock(list, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.BUTTON_PLANKS_PAINTED, color);
+		list.add(new ItemStack(Blocks.WOOL, 1, painted(Blocks.WOOL).toMetadata(color)));
+		addPaintedWoodBlock(list, Blocks.PLANKS_OAK_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.STAIRS_PLANKS_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.SLAB_PLANKS_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.FENCE_PLANKS_OAK_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.TRAPDOOR_PLANKS_PAINTED, color);
+		addPaintedWoodBlock(list, Blocks.CHEST_PLANKS_OAK_PAINTED, color);
+		list.add(new ItemStack(Items.DOOR_OAK_PAINTED, 1, color.itemMeta));
+		list.add(new ItemStack(Items.SIGN_PAINTED, 1, color.itemMeta));
+	}
+
+	private static void addPaintedWoodBlock(List<ItemStack> list, Block<?> block, DyeColor color) {
+		list.add(new ItemStack(block, 1, painted(block).toMetadata(color)));
+	}
+
+	private static void addDyes(List<ItemStack> list) {
+		for (DyeColor color : RAINBOW_ORDER) {
+			list.add(new ItemStack(Items.DYE, 1, color.itemMeta));
+		}
+	}
+
+	private static void addNaturalTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.GRASS);
+		addBlock(list, Blocks.GRASS_RETRO);
+		addBlock(list, Blocks.DIRT);
+		addBlock(list, Blocks.PATH_DIRT);
+		addBlock(list, Blocks.FARMLAND_DIRT);
+		addBlock(list, Blocks.GRAVEL);
+		newLine(list);
+
+		addBlock(list, Blocks.GRASS_SCORCHED);
+		addBlock(list, Blocks.DIRT_SCORCHED);
+		addBlock(list, Blocks.DIRT_SCORCHED_RICH);
+		addBlock(list, Blocks.MUD);
+		addBlock(list, Blocks.MUD_BAKED);
+		addBlock(list, Blocks.BLOCK_CLAY);
+		newLine(list);
+
+		addBlock(list, Blocks.SAND);
+		addBlock(list, Blocks.BRIMSAND);
+		addBlock(list, Blocks.BRIMTHAW);
+		addBlock(list, Blocks.GLOWSTONE);
+		addBlock(list, Blocks.SULFUR);
+		addBlock(list, Blocks.SULFUR_HARDENED);
+		newLine(list);
+
+		addBlock(list, Blocks.ICE);
+		addBlock(list, Blocks.PERMAICE);
+		addBlock(list, Blocks.BLOCK_SNOW);
+		addBlock(list, Blocks.LAYER_SNOW);
+		addBlock(list, Blocks.BLOCK_ASH);
+		addBlock(list, Blocks.LAYER_ASH);
+		newLine(list);
+
+		addBlock(list, Blocks.BRICK_CLAY);
+		addBlock(list, Blocks.STAIRS_BRICK_CLAY);
+		addBlock(list, Blocks.SLAB_BRICK_CLAY);
+		addBlock(list, Blocks.BONESHALE);
+		addBlock(list, Blocks.BEDROCK);
+		addBlock(list, Blocks.OBSIDIAN);
+		newLine(list);
+
+		addBlock(list, Blocks.MAGMA);
+		addBlock(list, Blocks.SOULSAND);
+		addBlock(list, Blocks.SOULSCHIST);
+		addBlock(list, Blocks.THERMAL_VENT);
+		addBlock(list, Blocks.EMBER);
+		newLine(list);
+	}
+
+	private static void addFood(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.FOOD_APPLE));
+		list.add(new ItemStack(Items.FOOD_APPLE_GOLD));
+		list.add(new ItemStack(Items.FOOD_CHERRY));
+		list.add(new ItemStack(Items.FOOD_PORKCHOP_RAW));
+		list.add(new ItemStack(Items.FOOD_PORKCHOP_COOKED));
+		list.add(new ItemStack(Items.FOOD_VENISON_RAW));
+		list.add(new ItemStack(Items.FOOD_VENISON_COOKED));
+		list.add(new ItemStack(Items.FOOD_FISH_RAW));
+		list.add(new ItemStack(Items.FOOD_FISH_COOKED));
+		list.add(new ItemStack(Items.DUST_SUGAR));
+		list.add(new ItemStack(Items.EGG_CHICKEN));
+		list.add(new ItemStack(Items.SEEDS_WHEAT));
+		list.add(new ItemStack(Items.SEEDS_PUMPKIN));
+		list.add(new ItemStack(Items.WHEAT));
+		list.add(new ItemStack(Items.DOUGH));
+		list.add(new ItemStack(Items.FOOD_BREAD));
+		list.add(new ItemStack(Items.FOOD_COOKIE));
+		list.add(new ItemStack(Items.FOOD_CAKE));
+		list.add(new ItemStack(Items.FOOD_PUMPKIN_PIE));
+		list.add(new ItemStack(Items.BOWL));
+		list.add(new ItemStack(Items.FOOD_STEW_MUSHROOM));
+	}
+
+	private static void addOrganicTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.LEAVES_OAK);
+		addBlock(list, Blocks.LAYER_LEAVES_OAK);
+		addBlock(list, Blocks.LEAVES_OAK_RETRO);
+		addBlock(list, Blocks.LEAVES_PINE);
+		addBlock(list, Blocks.LEAVES_BIRCH);
+		addBlock(list, Blocks.LEAVES_CHERRY);
+		addBlock(list, Blocks.LEAVES_CHERRY_FLOWERING);
+		addBlock(list, Blocks.LEAVES_EUCALYPTUS);
+		addBlock(list, Blocks.LEAVES_THORN);
+		addBlock(list, Blocks.LEAVES_PALM);
+		addBlock(list, Blocks.LEAVES_SHRUB);
+		addBlock(list, Blocks.LEAVES_CACAO);
+		newLine(list);
+
+		addBlock(list, Blocks.SAPLING_OAK);
+		addBlock(list, Blocks.SAPLING_OAK_RETRO);
+		addBlock(list, Blocks.SAPLING_PINE);
+		addBlock(list, Blocks.SAPLING_BIRCH);
+		addBlock(list, Blocks.SAPLING_CHERRY);
+		addBlock(list, Blocks.SAPLING_EUCALYPTUS);
+		addBlock(list, Blocks.SAPLING_THORN);
+		addBlock(list, Blocks.SAPLING_PALM);
+		addBlock(list, Blocks.SAPLING_SHRUB);
+		addBlock(list, Blocks.SAPLING_CACAO);
+		newLine(list);
+
+		list.add(new ItemStack(Blocks.FLOWER_YELLOW, 1, 0));
+		list.add(new ItemStack(Blocks.FLOWER_RED, 1, 0));
+		list.add(new ItemStack(Blocks.FLOWER_PINK, 1, 0));
+		list.add(new ItemStack(Blocks.FLOWER_PURPLE, 1, 0));
+		list.add(new ItemStack(Blocks.FLOWER_LIGHT_BLUE, 1, 0));
+		list.add(new ItemStack(Blocks.FLOWER_ORANGE, 1, 0));
+
+		addBlock(list, Blocks.MUSHROOM_BROWN);
+		addBlock(list, Blocks.MUSHROOM_RED);
+		newLine(list);
+
+		addBlock(list, Blocks.TALLGRASS);
+		addBlock(list, Blocks.TALLGRASS_FERN);
+		addBlock(list, Blocks.DEADBUSH);
+		addBlock(list, Blocks.SPINIFEX);
+		addBlock(list, Blocks.ALGAE);
+		addBlock(list, Blocks.CACTUS);
+		newLine(list);
+
+		addBlock(list, Blocks.COBWEB);
+		addBlock(list, Blocks.BONE_PILE);
+		addBlock(list, Blocks.SOUL_CATCHER);
+		addBlock(list, Blocks.BOULDER_MAGMATIC);
+		addBlock(list, Blocks.BOULDER_SULFURIC);
+		newLine(list);
+
+		addBlock(list, Blocks.PUMPKIN);
+		addBlock(list, Blocks.PUMPKIN_CARVED_IDLE);
+		addBlock(list, Blocks.PUMPKIN_CARVED_ACTIVE);
+
+		addBlock(list, Blocks.BLOCK_SUGARCANE);
+		addBlock(list, Blocks.BLOCK_SUGARCANE_BAKED);
+		newLine(list);
+
+		addBlock(list, Blocks.SPONGE_DRY);
+		addBlock(list, Blocks.SPONGE_WET);
+
+		addBlock(list, Blocks.PUMICE_DRY);
+		addBlock(list, Blocks.PUMICE_WET);
+		newLine(list);
+	}
+
+	private static void addWorkstationsAndGlass(List<ItemStack> list) {
+		addBlock(list, Blocks.WORKBENCH);
+		addBlock(list, Blocks.FURNACE_STONE_IDLE);
+		addBlock(list, Blocks.FURNACE_BLAST_IDLE);
+		addBlock(list, Blocks.TROMMEL_IDLE);
+		addBlock(list, Blocks.BOOKSHELF_PLANKS_OAK);
+		addBlock(list, Blocks.LADDER_OAK);
+		addBlock(list, Blocks.TORCH_COAL);
+		addBlock(list, Blocks.GLASS);
+		addBlock(list, Blocks.TRAPDOOR_GLASS);
+		addBlock(list, Blocks.GLASS_TINTED);
+		addBlock(list, Blocks.GLASS_STEEL);
+	}
+
+	private static void addArmor(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.ARMOR_HELMET_LEATHER));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_LEATHER));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_LEATHER));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_LEATHER));
+		list.add(new ItemStack(Items.ARMOR_WOLF_LEATHER));
+		list.add(new ItemStack(Items.ARMOR_QUIVER));
+		newLine(list);
+
+		list.add(new ItemStack(Items.ARMOR_HELMET_CHAINMAIL));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_CHAINMAIL));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_CHAINMAIL));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_CHAINMAIL));
+		list.add(new ItemStack(Items.ARMOR_WOLF_CHAINMAIL));
+		list.add(new ItemStack(Items.ARMOR_QUIVER_GOLD));
+		newLine(list);
+
+		list.add(new ItemStack(Items.ARMOR_HELMET_IRON));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_IRON));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_IRON));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_IRON));
+		list.add(new ItemStack(Items.ARMOR_WOLF_IRON));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_ICESKATES));
+		newLine(list);
+
+		list.add(new ItemStack(Items.ARMOR_HELMET_GOLD));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_GOLD));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_GOLD));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_GOLD));
+		list.add(new ItemStack(Items.ARMOR_WOLF_GOLD));
+		newLine(list);
+
+		list.add(new ItemStack(Items.ARMOR_HELMET_DIAMOND));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_DIAMOND));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_DIAMOND));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_DIAMOND));
+		list.add(new ItemStack(Items.ARMOR_WOLF_DIAMOND));
+		newLine(list);
+
+		list.add(new ItemStack(Items.ARMOR_HELMET_STEEL));
+		list.add(new ItemStack(Items.ARMOR_CHESTPLATE_STEEL));
+		list.add(new ItemStack(Items.ARMOR_LEGGINGS_STEEL));
+		list.add(new ItemStack(Items.ARMOR_BOOTS_STEEL));
+		list.add(new ItemStack(Items.ARMOR_WOLF_STEEL));
+		newLine(list);
+
+
+
+
+		newLine(list);
+
+
+	}
+
+	private static void addRedstoneTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.BLOCK_REDSTONE);
+		list.add(new ItemStack(Items.DUST_REDSTONE));
+		list.add(new ItemStack(Items.REPEATER));
+		list.add(new ItemStack(Items.TIMER));
+		addBlock(list, Blocks.TORCH_REDSTONE_ACTIVE);
+		addBlock(list, Blocks.LEVER_COBBLE_STONE);
+
+		addBlock(list, Blocks.PUMPKIN_REDSTONE);
+		addBlock(list, Blocks.PISTON_BASE);
+		addBlock(list, Blocks.PISTON_BASE_STICKY);
+		addBlock(list, Blocks.PISTON_BASE_STEEL);
+		addBlock(list, Blocks.DISPENSER_COBBLE_STONE);
+		addBlock(list, Blocks.MOTION_SENSOR_IDLE);
+		newLine(list);
+
+		addBlock(list, Blocks.ACTIVATOR);
+		addBlock(list, Blocks.MATCHER);
+		addBlock(list, Blocks.CONDUIT);
+		addBlock(list, Blocks.RUBYGLASS_COLUMN);
+		addBlock(list, Blocks.RUBYGLASS_NODE);
+		addBlock(list, Blocks.BLOCK_RUBYGLASS);
+		addBlock(list, Blocks.RUBYGLASS_GROWTH);
+		addBlock(list, Blocks.RUBYGLASS_CRYSTAL);
+		addBlock(list, Blocks.MESH);
+		addBlock(list, Blocks.MESH_GOLD);
+		addBlock(list, Blocks.MOBSPAWNER);
+		addBlock(list, Blocks.MOBSPAWNER_DEACTIVATED);
+		addBlock(list, Blocks.RAIL);
+		addBlock(list, Blocks.RAIL_POWERED);
+		addBlock(list, Blocks.RAIL_DETECTOR);
+		list.add(new ItemStack(Items.MINECART));
+		list.add(new ItemStack(Items.MINECART_CHEST));
+		list.add(new ItemStack(Items.MINECART_FURNACE));
+		list.add(new ItemStack(Items.SADDLE));
+		list.add(new ItemStack(Items.BOAT));
+		addBlock(list, Blocks.NOTEBLOCK);
+		addBlock(list, Blocks.JUKEBOX);
+		addBlock(list, Blocks.TNT);
+		addBlock(list, Blocks.SPIKES);
+		newLine(list);
+	}
+
+	private static void addOreTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.ORE_COAL_STONE);
+		addBlock(list, Blocks.ORE_COAL_BASALT);
+		addBlock(list, Blocks.ORE_COAL_LIMESTONE);
+		addBlock(list, Blocks.ORE_COAL_GRANITE);
+		addBlock(list, Blocks.ORE_COAL_PERMAFROST);
+		newLine(list);
+
+		addBlock(list, Blocks.ORE_IRON_STONE);
+		addBlock(list, Blocks.ORE_IRON_BASALT);
+		addBlock(list, Blocks.ORE_IRON_LIMESTONE);
+		addBlock(list, Blocks.ORE_IRON_GRANITE);
+		addBlock(list, Blocks.ORE_IRON_PERMAFROST);
+		newLine(list);
+
+		addBlock(list, Blocks.ORE_GOLD_STONE);
+		addBlock(list, Blocks.ORE_GOLD_BASALT);
+		addBlock(list, Blocks.ORE_GOLD_LIMESTONE);
+		addBlock(list, Blocks.ORE_GOLD_GRANITE);
+		addBlock(list, Blocks.ORE_GOLD_PERMAFROST);
+		newLine(list);
+
+		addBlock(list, Blocks.ORE_LAPIS_STONE);
+		addBlock(list, Blocks.ORE_LAPIS_BASALT);
+		addBlock(list, Blocks.ORE_LAPIS_LIMESTONE);
+		addBlock(list, Blocks.ORE_LAPIS_GRANITE);
+		addBlock(list, Blocks.ORE_LAPIS_PERMAFROST);
+
+		addBlock(list, Blocks.ORE_NETHERCOAL_BASALT);
+		newLine(list);
+
+		addBlock(list, Blocks.ORE_REDSTONE_STONE);
+		addBlock(list, Blocks.ORE_REDSTONE_BASALT);
+		addBlock(list, Blocks.ORE_REDSTONE_LIMESTONE);
+		addBlock(list, Blocks.ORE_REDSTONE_GRANITE);
+		addBlock(list, Blocks.ORE_REDSTONE_PERMAFROST);
+
+		addBlock(list, Blocks.ORE_NETHERCOAL_NETHERRACK);
+		newLine(list);
+
+		addBlock(list, Blocks.ORE_DIAMOND_STONE);
+		addBlock(list, Blocks.ORE_DIAMOND_BASALT);
+		addBlock(list, Blocks.ORE_DIAMOND_LIMESTONE);
+		addBlock(list, Blocks.ORE_DIAMOND_GRANITE);
+		addBlock(list, Blocks.ORE_DIAMOND_PERMAFROST);
+
+		addBlock(list, Blocks.ORE_NETHERCOAL_GLOOMSTONE);
+		newLine(list);
+
+
+
+
+	}
+
+	private static void addOreProducts(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.AMMO_PEBBLE));
+		list.add(new ItemStack(Items.COAL));
+		list.add(new ItemStack(Items.COAL, 1, 1));
+		list.add(new ItemStack(Items.NETHERCOAL));
+		list.add(new ItemStack(Items.OLIVINE));
+		list.add(new ItemStack(Items.ORE_RAW_IRON));
+		list.add(new ItemStack(Items.INGOT_IRON));
+		list.add(new ItemStack(Items.ORE_RAW_GOLD));
+		list.add(new ItemStack(Items.INGOT_GOLD));
+		list.add(new ItemStack(Items.INGOT_STEEL_CRUDE));
+		list.add(new ItemStack(Items.INGOT_STEEL));
+		list.add(new ItemStack(Items.QUARTZ));
+		list.add(new ItemStack(Items.RUBYGLASS));
+		list.add(new ItemStack(Items.DIAMOND));
+		list.add(new ItemStack(Items.FLINT));
+		list.add(new ItemStack(Items.CLAY));
+		list.add(new ItemStack(Items.BRICK_CLAY));
+		list.add(new ItemStack(Items.SULFUR));
+		list.add(new ItemStack(Items.DUST_GLOWSTONE));
+	}
+
+	private static void addStorageTypes(List<ItemStack> list) {
+		addBlock(list, Blocks.BLOCK_IRON);
+		addBlock(list, Blocks.BLOCK_STEEL);
+		addBlock(list, Blocks.BLOCK_GOLD);
+		addBlock(list, Blocks.BLOCK_LAPIS);
+		addBlock(list, Blocks.BLOCK_DIAMOND);
+		addBlock(list, Blocks.BLOCK_QUARTZ);
+		addBlock(list, Blocks.BLOCK_COAL);
+		addBlock(list, Blocks.BLOCK_CHARCOAL);
+		addBlock(list, Blocks.BLOCK_NETHER_COAL);
+		addBlock(list, Blocks.BLOCK_OLIVINE);
+		newLine(list);
+
+		addBlock(list, Blocks.BRICK_IRON);
+		addBlock(list, Blocks.STAIRS_BRICK_IRON);
+		addBlock(list, Blocks.SLAB_BRICK_IRON);
+		addBlock(list, Blocks.BRICK_GOLD);
+		addBlock(list, Blocks.STAIRS_BRICK_GOLD);
+		addBlock(list, Blocks.SLAB_BRICK_GOLD);
+		newLine(list);
+
+		addBlock(list, Blocks.BRICK_DIAMOND);
+		addBlock(list, Blocks.STAIRS_BRICK_DIAMOND);
+		addBlock(list, Blocks.SLAB_BRICK_DIAMOND);
+		addBlock(list, Blocks.BRICK_STEEL);
+		addBlock(list, Blocks.STAIRS_BRICK_STEEL);
+		addBlock(list, Blocks.SLAB_BRICK_STEEL);
+		newLine(list);
+
+		addBlock(list, Blocks.BRICK_QUARTZ);
+		addBlock(list, Blocks.STAIRS_BRICK_QUARTZ);
+		addBlock(list, Blocks.SLAB_BRICK_QUARTZ);
+		addBlock(list, Blocks.BRICK_LAPIS);
+		addBlock(list, Blocks.STAIRS_BRICK_LAPIS);
+		addBlock(list, Blocks.SLAB_BRICK_LAPIS);
+		newLine(list);
+
+		addBlock(list, Blocks.BRICK_OLIVINE);
+		addBlock(list, Blocks.STAIRS_BRICK_OLIVINE);
+		addBlock(list, Blocks.SLAB_BRICK_OLIVINE);
+		addBlock(list, Blocks.BRICK_RUBYGLASS);
+		addBlock(list, Blocks.STAIRS_BRICK_RUBYGLASS);
+		addBlock(list, Blocks.SLAB_BRICK_RUBYGLASS);
+		newLine(list);
+
+	}
+
+	private static void addBasics(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.STICK));
+		list.add(new ItemStack(Items.AMMO_SNOWBALL));
+		list.add(new ItemStack(Items.SUGARCANE));
+		list.add(new ItemStack(Items.PAPER));
+		list.add(new ItemStack(Items.BOOK));
+	}
+
+	private static void addMobDrops(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.CLOTH));
+		list.add(new ItemStack(Items.STRING));
+		list.add(new ItemStack(Items.FEATHER_CHICKEN));
+		list.add(new ItemStack(Items.GUNPOWDER));
+		list.add(new ItemStack(Items.BONE));
+		list.add(new ItemStack(Items.CHAINLINK));
+		list.add(new ItemStack(Items.SLIMEBALL));
+		list.add(new ItemStack(Items.LEATHER));
+	}
+
+	private static void addPlaceables(List<ItemStack> list) {
+		addBlock(list, Blocks.PAPER_WALL);
+		addBlock(list, Blocks.FENCE_PAPER_WALL);
+
+		addBlock(list, Blocks.FENCE_CHAINLINK);
+		addBlock(list, Blocks.FENCE_STEEL);
+
+		list.add(new ItemStack(Items.PAINTING));
+		newLine(list);
+
+		list.add(new ItemStack(Items.DOOR_GLASS));
+		list.add(new ItemStack(Items.DOOR_IRON));
+		list.add(new ItemStack(Items.DOOR_STEEL));
+		addBlock(list, Blocks.TRAPDOOR_IRON);
+		addBlock(list, Blocks.TRAPDOOR_STEEL);
+		newLine(list);
+
+		list.add(new ItemStack(Items.FLAG));
+		list.add(new ItemStack(Items.BED));
+		list.add(new ItemStack(Items.SEAT));
+		addBlock(list, Blocks.BRAZIER_INACTIVE);
+		list.add(new ItemStack(Items.BASKET));
+		list.add(new ItemStack(Items.JAR));
+		newLine(list);
+
+		list.add(new ItemStack(Items.LANTERN_FIREFLY_GREEN));
+		list.add(new ItemStack(Items.LANTERN_FIREFLY_BLUE));
+		list.add(new ItemStack(Items.LANTERN_FIREFLY_ORANGE));
+		list.add(new ItemStack(Items.LANTERN_FIREFLY_RED));
+		newLine(list);
+
+		list.add(new ItemStack(Items.JAR_BUTTERFLY_BLUE));
+		list.add(new ItemStack(Items.JAR_BUTTERFLY_ORANGE));
+		list.add(new ItemStack(Items.JAR_BUTTERFLY_PINK));
+		list.add(new ItemStack(Items.JAR_BUTTERFLY_SILVER));
+	}
+
+	private static void addRecords(@NotNull List<ItemStack> list) {
+		list.add(new ItemStack(Items.RECORD_13));
+		list.add(new ItemStack(Items.RECORD_CAT));
+		list.add(new ItemStack(Items.RECORD_BLOCKS));
+		list.add(new ItemStack(Items.RECORD_CHIRP));
+		list.add(new ItemStack(Items.RECORD_FAR));
+		list.add(new ItemStack(Items.RECORD_MALL));
+		list.add(new ItemStack(Items.RECORD_MELLOHI));
+		list.add(new ItemStack(Items.RECORD_STAL));
+		list.add(new ItemStack(Items.RECORD_STRAD));
+		list.add(new ItemStack(Items.RECORD_WARD));
+		list.add(new ItemStack(Items.RECORD_WAIT));
+		list.add(new ItemStack(Items.RECORD_DOG));
+	}
+
+	private static void addBucketVariants(List<ItemStack> list, Item item) {
+		if (item instanceof ItemBucket itemBucket) {
+			list.add(new ItemStack(item));
+			for (NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
+				if (!ItemBucket.STATE_EMPTY.equals(stateId)) {
+					ItemStack itemStack = new ItemStack(item, 1);
+					ItemBucket.setState(itemStack, stateId);
+					ItemBucket.setCharges(itemStack, itemBucket.maxCharges);
+					list.add(itemStack);
+				}
+			}
+		}
+	}
+
+	private static void addBlock(List<ItemStack> list, Block<?> @NotNull ... blocks) {
+		for (Block<?> block : blocks) {
+			list.add(new ItemStack(block));
+		}
+	}
+
+	private static @NotNull IPainted painted(@NotNull Block<?> block) {
+		return (IPainted) block.getLogic();
+	}
+}
